#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <util/atomic.h>
#include "lcd.h"

volatile uint32_t frequency = 0;
volatile uint32_t overflows = 0;

int main(void) {
	lcdInit();
	lcdInitPrintf();
	//wcz przerwania globalnie
	sei();
	//sygna zegarowy na T0
	TCCR0 = _BV(CS02) | _BV(CS01) | _BV(CS00);
	//CLK/1024
	TCCR1B = _BV(WGM12) | _BV(CS12) | _BV(CS10);
	OCR1A = 15624;
	//przerwania na przepenienie Tim0 i output capture Tim1
	TIMSK = _BV(TOIE0) | _BV(OCIE1A); 
	while(1) {
		lcdGotoXY(0, 0);
		printf("%6g Hz", (double)frequency);
		_delay_ms(500);
	}
}

ISR(TIMER0_OVF_vect){
	overflows++;
}

ISR(TIMER1_COMPA_vect){
	frequency = TCNT0 + overflows * 256;
	overflows = 0;
	TCNT0 = 0;
}